/* Copyright (c) 2006-2015 Polybus Systems Corp., Westford, MA, USA */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */


Boolean averageResults(result *results,result *final);
Boolean findSubString(char *src,char *match);
Boolean getCharStream(char *filename,char *array,SInt32 limit);
Boolean getSwitch(char *arg,char *string);
Boolean getSwitchArg(char *arg,char *string);
Boolean getSysFile(char *filename,char *array,SInt32 limit);
Boolean getSysInfo(char **buffer,char *param,SInt64 *value);
Boolean logicalToPhysical(UInt64 logical,UInt64 *physical);
Boolean testEnb(long test,UInt64 select);
FILE *getPageMap(void);
SInt32 displayLongPassFail(char *prefix,SInt32 values[],SInt32 exp[],SInt32 count);
SInt32 getVerbose(void);
SInt64 decimalToInt(char *srcString);
UInt64 byteToLWord(char *data,SInt32 offset,SInt32 bytes);
UInt64 getEntry(char *data,SInt32 offset,SInt32 bytes);
char *countBankError(UInt64 addr);
char *getRevision(void);
double getTime(void);
long displayFloatPassFail(char *prefix,float values[],float exp[],long count);
long displayPassFail(char *prefix,double values[],double exp[],long count);
long displaySInt16PassFail(char *prefix,SInt16 values[],SInt16 exp[],long count);
long displaySInt64PassFail(char *prefix,SInt64 values[],SInt64 exp[],long count);
long getDirName(long num,long indx,file_info *finfo,char *string);
long getPathName(long num,long size,long indx,file_info *finfo,char *string);
long strToInt(char *srcString);
void *getDMIEntry(dmi_entry *dmi_table,dmi_entry *entry);
void averageAllResults(SInt32 from,SInt32 to,result_summary *results,result_summary *final_results,run_summary *ran,SInt32 MAX_THREADS);
void bandWidth(char *prefix,SInt64 length,double rusecs,double wusecs);
void chkDouble(long firsttime,double exp,double got,result *rslt);
void chkFloat(long firsttime,float exp,float got,result *rslt);
void chkSInt16(long firsttime,SInt16 exp,SInt16 got,result *rslt);
void chkSInt32(long firsttime,SInt32 exp,SInt32 got,result *rslt);
void chkSInt64(long firsttime,SInt64 exp,SInt64 got,result *rslt);
void chkUInt16(long firsttime,UInt16 exp,UInt16 got,result *rslt);
void chkUInt32(long firsttime,UInt32 exp,UInt32 got,result *rslt);
void chkUInt64(long firsttime,UInt64 exp,UInt64 got,result *rslt);
void closePageMap(void);
void closeTranscript(void);
void clrExpected(exp_data *exp);
void clrResults(result_summary *result);
void commaFormat(char *string,SInt64 value);
void commaNumber(double value,char *num);
void cpuRest(double ttime,double dutyscale);
void cpyUpCase(char *des, char *src);
void delay(SInt32 seconds);
void displayBWResults(FILE *fp,FILE *csv,result *rslt,char *unit);
void displayDiskResults(FILE *fp,FILE *csv,result rslt[MAX_DIRS][NUM_DISK_MODES][MAX_FILE_SIZES],char *unit,file_info *finfo,char *lunit,char *ltype);
void displayFPResults(FILE *fp,FILE *csv,result rslt[NUM_FP_TESTS][MAX_SIZES],char *unit);
void displayFixResults(FILE *fp,FILE *csv,SInt32 num,result *rslt);
void displayHexFloat(char *prefix,char *unit,float values[],long count);
void displayHexLine(char *prefix,char *unit,double values[],long count);
void displayLine(char *prefix,char *unit,double values[],long count);
void displayMemResults(FILE *fp,FILE *csv,result *rslt);
void displayResults(FILE *fp,FILE *csv,result *rslt);
void displayStatusLine(char *prefix,char *unit,double values[],long count,long status);
void displayTitles(char *prefix,char *values[],long count);
void downCaseString(char *string);
void explainIt(void);
void flushTranscript(void);
void getDMIInfo(void);
void getVersion(void);
void iscale(char *string,char *postfix,double value);
void leftJustifyString(char *src,char *des,long width);
void memSize(char *string,SInt64 size);
void minMaxTemps(long num_values,double feature_value[],double min[],double max[],Boolean firstTime);
void mprint(long width,char *prefix,SInt64 value);
void mscale(long width,char *string,char *prefix,char *postfix,SInt64 ivalue);
void mySysInfo(my_sysinfo *sys_info);
void openDMIFile(char *filename);
void openPageMap(void);
void openTranscript(char *report_name);
void pad2length(char *string,SInt32 length);
void parseDMITable(void);
void pathCopy(char *des,char *src,long limit);
void printBankErrorSummary(FILE *fp,FILE *csv);
void printCPUFrequency(char *title,char *filename,Boolean current);
void printDMIEntries(void);
void printMinMaxSensors(FILE *fp,FILE *csv,long num_temps,char temp_names[64][64],double min[],double max[]);
void printPeakCPU(FILE *fp,FILE *csv);
void printRamSize(FILE *fp,FILE *csv,char *name,SInt64 size);
void printSensors(FILE *fp,long num_temps,char temp_names[64][64],double value[],char *prefix);
void printTestName(char *name,SInt64 length);
void printTime(void);
void printTranscript(char *string,Boolean print_always);
void rightJustifyString(char *src,char *des,long width);
void scale(char *string,char *postfix,double value);
void setVerbose(SInt32 value);
void translatePages(UInt64 base,SInt32 num_pages);
void translateString(char xlateTable[],char *string);
void upCaseString(char *string);
void updateBandwidth(double bandwidth,double xtime,double ops,result *rslt);
void writeResults(FILE *fp,FILE *csv,long thread_cnt,result_summary *results,run_summary *ran,file_info *finfo);
